#define Tree struct bitree
#define ElemType Tree* 
#include "ʵ3--ԭ.cpp"
#include <math.h> 

struct bitree{
	char dat;
	struct bitree* lchild;
	struct bitree* rchild; 
};

void PrintMenu(void) {
	cout << "***********************************" << endl; 
	cout << "0-˳" << endl;
	cout << "1-a" << endl;
	cout << "2-ɾa" << endl;
	cout << "3-a" << endl;
	cout << "4-ͳƽҶӽ߶" << endl;
	cout << "a-" << endl;
	cout << "b-ҽǷڡ˫ס" << endl;
	cout << "c-ж϶" << endl;
	cout << "d-" << endl;
	cout << "e-ɾڵµ" << endl; 
	cout << "5-b" << endl;
	cout << "f-aƵb" << endl;
	cout << "6-ɾb" << endl;
	cout << "7-b" << endl;
	cout << "g-abȵҶӴb" << endl;
	cout << "***********************************" << endl; 
}

void InitBiTree(Tree* &t) {
	char a;
	cin >> a;
	if (a != '#') {
		t = new Tree;
		t->dat = a;
		InitBiTree(t->lchild);
		InitBiTree(t->rchild);
	}
	else t = NULL;
}

void DestroyBiTree(Tree* &t) {
	if (!t) return;
	DestroyBiTree(t->lchild);
	DestroyBiTree(t->rchild);
	delete t;
	t = NULL;
}

void PreOrder(Tree* t) {
	if (!t) return;
	cout << t->dat;
	PreOrder(t->lchild);
	PreOrder(t->rchild);
}

void InOrder(Tree* t) {
	if (!t) return;
	InOrder(t->lchild);
	cout << t->dat;
	InOrder(t->rchild);
}

void PostOrder(Tree* t) {
	if (!t) return;
	PostOrder(t->lchild);
	PostOrder(t->rchild);
	cout << t->dat;
}

int nodes(Tree* t) {
	if(!t) return 0;
	return nodes(t->lchild)+nodes(t->rchild)+1;
}

int leaves(Tree* t) {
	if(!t) return 0;
	if(!t->lchild && !t->rchild) return 1;
	return leaves(t->lchild)+leaves(t->rchild);
}

int height(Tree* t) {
	if(!t) return 0;
	return max(height(t->lchild), height(t->rchild))+1;
}

void LevelOrder(node* q, Tree* t) {
	Tree* s;
	InitQueue(q);
	EnQueue(q, t);
	while (!GetTop(q, s)) {
		DeQueue(q, s);
		if (s) {
			cout << s->dat;
			EnQueue(q, s->lchild);
			EnQueue(q, s->rchild);
		}
	}
	DestroyQueue(q);
}

void SearchValue(node* q, Tree* t) {
	char n;
	while(getchar() != '\n');
	cin >> n;
	Tree *s, *r;
	if (t->dat == n) {
		cout << "" << n << "" << endl;
		cout << "޸" << endl;
		if (!t->lchild) cout << "" << endl;
		else cout << "Ϊ" << t->lchild->dat << endl;
		if (!t->rchild) cout << "Һ" << endl;
		else cout << "ҺΪ" << t->rchild->dat << endl;
		return;
	}
	InitQueue(q);
	EnQueue(q, t);
	while (!GetTop(q, s)) {
		DeQueue(q, s);
		if (s) {
			if (s->lchild && s->lchild->dat == n) {
				cout << "" << n << "" << endl;
				cout << "Ϊ" << s->dat <<  endl;
				r = s->lchild;
				if (!r->lchild) cout << "" << endl;
		        else cout << "Ϊ" << r->lchild->dat << endl;
		        if (!r->rchild) cout << "Һ" << endl;
		        else cout << "ҺΪ" << r->rchild->dat << endl;
		        DestroyQueue(q);
		        return;
			}
			if (s->rchild && s->rchild->dat == n) {
				cout << "" << n << "" << endl;
				cout << "Ϊ" << s->dat <<  endl;
			    r = s->rchild;
				if (!r->lchild) cout << "" << endl;
		        else cout << "Ϊ" << r->lchild->dat << endl;
		        if (!r->rchild) cout << "Һ" << endl;
		        else cout << "ҺΪ" << r->rchild->dat << endl;
		        DestroyQueue(q);
		        return;
			}
			EnQueue(q, s->lchild);
			EnQueue(q, s->rchild);
		}
	}
	cout << "" << n << "" << endl;
	DestroyQueue(q);
    return;
}

bool JudgeSequence(Tree* t) {
	Tree *s;
	if (!t) return 1;
	if (t->lchild) {
		s = t->lchild;
		while(s->lchild) s = s->lchild;
		if (s->dat >= t->dat) return 0;
	}
    if (t->rchild) {
		s = t->rchild;
		while(s->rchild) s = s->rchild;
		if (s->dat < t->dat) return 0;
	}
	return JudgeSequence(t->lchild)*JudgeSequence(t->rchild);
}

bool JudgeComplete(Tree* t) {
	return !(pow(2, height(t)) - nodes(t) - 1);
}

bool JudgeBalance(Tree* t) {
	if (!t) return 1;
	int x = height(t->lchild) - height(t->rchild);
	if (x > 1 || x < -1) return 0;
	return JudgeBalance(t->lchild)*JudgeBalance(t->rchild); 
}

void Swap(Tree* t) {
	if (!t) return;
	Tree* s;
	Swap(t->lchild);
	Swap(t->rchild);
	s = t->lchild;
	t->lchild = t->rchild;
	t->rchild = s;
}

void Delete(node* q, Tree* &t) {
	char n;
	while(getchar() != '\n');
	cin >> n;
	if (t->dat == n) {
		DestroyBiTree(t);
		return;
	}
	Tree* s;
	InitQueue(q);
	EnQueue(q, t);
	while (!GetTop(q, s)) {
		DeQueue(q, s);
		if (s) {
			if (s->lchild && s->lchild->dat == n) {
				DestroyBiTree(s->lchild);
				DestroyQueue(q);
				s->lchild = NULL;
				return;
			}
			if (s->rchild && s->rchild->dat == n) {
				DestroyBiTree(s->rchild);
				DestroyQueue(q);
				s->rchild = NULL;
				return;
			}
			EnQueue(q, s->lchild);
			EnQueue(q, s->rchild);
		}
	}
	cout << "Ԫδҵ" << endl; 
}

void CopyBiTree(Tree* &t1, Tree* t2) {
	t1 = t2;
	if (t2->lchild) CopyBiTree(t1->lchild, t2->lchild);
	else t1->lchild = NULL;
	if (t2->rchild) CopyBiTree(t1->rchild, t2->rchild);
	else t1->rchild = NULL;
}

void InsertBiTree(node* q, Tree* &t1, Tree* t2) {
	if (!t2) {
		cout << "󣺲Ϊ" << endl;
		return;
	}
	char n = t2->dat;
	Tree *s;
	InitQueue(q);
	EnQueue(q, t1);
	while (!GetTop(q, s)) {
		DeQueue(q, s);
		if (s) {
			if (s->dat == n) {
				if (!s->lchild && !s->rchild) {
					s->lchild = t2->lchild;
					s->rchild = t2->rchild;
					DestroyQueue(q);
		    		return;
				}
				cout << "󣺲봦ΪҶ" << endl;
				DestroyQueue(q);
		        return;
			}
			EnQueue(q, s->lchild);
			EnQueue(q, s->rchild);
		}
	}
	DestroyQueue(q);
	cout << "Ԫδҵ" << endl;
}

int main(void) {
	Tree *a = NULL, *b = NULL;
	node* q = NULL;
	char n;
	cout << "سʼ" << endl; 
	while (1) {
		while(getchar() != '\n');
		PrintMenu();
		cin >> n;
		switch (n) {
			case '0':
			    exit(0);
			
			case '1':
				InitBiTree(a);
				break;
			
			case '2': 
			    DestroyBiTree(a);
			    break;
			    
			case '3':
			    cout << ""; PreOrder(a); cout << endl;
			    cout << ""; InOrder(a); cout << endl;
				cout << ""; PostOrder(a); cout << endl;
			    break;
			    
			case '4': 
			    cout << "" << nodes(a) << endl;
				cout << "Ҷӽ" << leaves(a) << endl;
			    cout << "߶ȣ" << height(a) << endl;
			    break;
			    
			case 'a':
				LevelOrder(q, a);
				cout << endl;
				break;
				
			case 'b':
				SearchValue(q, a);
				break;
				
			case 'c':
			    if (!JudgeSequence(a)) cout << ""; cout << "Ϊ" << endl;
			    if (!JudgeComplete(a)) cout << ""; cout << "Ϊȫ" << endl;
			    if (!JudgeBalance(a)) cout << ""; cout << "Ϊƽ" << endl;
			    break;
			
			case 'd':
			    Swap(a);
			    break;
			    
			case 'e':
				Delete(q, a);
				break;
				
			case '5':
				InitBiTree(b);
				break;
				
			case 'f':
				CopyBiTree(b, a);
				break;
				
			case '6':
				DestroyBiTree(b);
				break;
				
			case '7':
			    cout << ""; PreOrder(b); cout << endl;
			    cout << ""; InOrder(b); cout << endl;
				cout << ""; PostOrder(b); cout << endl;
			    break;
			    
			case 'g':
				InsertBiTree(q, a, b);
				break;
							
			default:
				cout << "" << endl;
		}
		
	}
}

