#include <iostream>
using namespace::std; 

class DSTable{
private:
	int H;
	int length;
	int* content;
	int data;
	int MaxInsertTimes;
	float MaxAverageLength;
	float AverageLength;
	int empty;
	int tomb;
	
public:
    void InitDSTable(void);
	void DestroyDSTable(void);
	int InsertNum(int key);
	int DeleteNum(int key);
	int Search(int key);
	float CountAveLength(void);
	void TraverseDSTable(void);
	void RestructDSTable(void);
};

void PrintMenu(void) {
	cout << "***************************" << endl; 
	cout << "0-˳" << endl;
	cout << "1-ұ" << endl;
	cout << "2-ɾұ" << endl;
	cout << "3-Ԫ" << endl;
	cout << "a-ɾԪ" << endl;
	cout << "4-Ԫ" << endl;
	cout << "b-ƽҳ" << endl;
	cout << "5-ұ" << endl;
	cout << "c-ؽұ" << endl;
	cout << "***************************" << endl; 
}

void DSTable::InitDSTable(void){
	int m, i;
	data = 0;
	cout << "룺   ƽҳ նӦֵ ĹӦֵ" << endl;
	while (getchar() != '\n');
	cin >> H;
	cin >> length;
	cin >> MaxInsertTimes;
	cin >> MaxAverageLength;
	cin >> empty;
	cin >> tomb;
	while (getchar() != '\n');
	content = new int[length];
	for (i = 0; i < length; i++) content[i] = empty;
	cout << "ݣֵԽ" << endl;
	cin >> m;
	while (m != empty) {
	    InsertNum(m);
	    cin >> m;
	}
}

void DSTable::DestroyDSTable(void){
	delete[] content;
}

int DSTable::InsertNum(int key) {
	if (Search(key) + 1) {
		cout << "Ѵڣʧ" << endl;
		return -1;
	}
	int i, c = 0;
	for (i = key % H; content[i] != empty; ) {
		if (++c == MaxInsertTimes) {
			cout << "࣬ʧܣؽ" << endl;
			return -1;
		}
		if (++i == length) i = 0;
	}
	content[i] = key;
	data++;
	return i;
}

int DSTable::DeleteNum(int key) {
    int m;
    if ((m =Search(key)) == -1) {
		cout << "ڣɾʧ" << endl;
		return -1;
	}
	content[m] = tomb;
	data--;
}

int DSTable::Search(int key) {
	int i, c = 0;
	for (i = key % H; content[i] != key; i++) {
		if (++c == MaxInsertTimes || content[i] == empty) return -1;
		if (i == length) i = 0; 
	}
	return i;
}

float DSTable::CountAveLength(void) {
	int i;
	float m = 0;
	int t;
	for (i = 0; i < length; i++) if (content[i] != empty && content[i] != tomb) {
		t =  i - (content[i] % H);
		if (t < 0) t += H;
		m += t + 1;
	}
	AverageLength = m / data;
	if (AverageLength > MaxAverageLength) cout << "ƽҳȹؽ" << endl;
	return AverageLength;
}

void DSTable::TraverseDSTable(void) {
    int i;
    for (i = 0; i < length; i++) printf("%-3d", i);
    cout << endl;
    for (i = 0; i < length; i++) {
    	if (content[i] == empty) cout << "^  ";
    	else if (content[i] == tomb) cout << "+  ";
    	else printf("%-3d", content[i]);
	}
	cout << endl;
}

void DSTable::RestructDSTable(void) {
	int i, t = 0, m = data;
	int* num;
	num = new int[m];
	for (i = 0; i < length; i++) if (content[i] != empty && content[i] != tomb) num[t++] = content[i];
	cout << "룺 ±" << endl;
	while (getchar() != '\n');
	cin >> H;
	cin >> length;
	delete[] content;
	content = new int[length];
	for (i = 0; i < length; i++) content[i] = empty;
	data = 0;
	for (i = 0; i < m; i++) InsertNum(num[i]);
	delete[] num;
}

int main(void) {
	DSTable a;
	char n;
	int x;
	cout << "سʼ" << endl; 
	while (1) {
		while (getchar() != '\n');
		PrintMenu();
		cin >> n;
		switch (n) {
			case '0':
			    exit(0);
			
			case '1':
				a.InitDSTable();
				break;
			
			case '2':
				a.DestroyDSTable();
			    break;
			    
			case '3':
				cin >> x;
				a.InsertNum(x);
			    break;
			    
			case 'a':
				cin >> x;
				a.DeleteNum(x); 
			    break;
			    
			case '4':
				cin >> x;
				cout << a.Search(x) << endl;
			    break;
				
			case 'b':
				cout << a.CountAveLength() << endl;
				break;
				
			case '5':
				a.TraverseDSTable(); 
			    break;
			    
			case 'c':
				a.RestructDSTable(); 
			    break;
							
			default:
				cout << "" << endl;
		}	
	}
}
